Scriptname aaaGoldXPMenuQuest extends SKI_ConfigBase  

;vars need to be global so that menu scripts and event scripts operate on the same config
GlobalVariable Property aaaGoldXPReductionConstant auto
GlobalVariable Property aaaGoldXPReductionCoefficient auto	
GlobalVariable Property aaaGoldXPReductionLogPower auto
GlobalVariable Property aaaGoldXPSkillXPCoefficient auto
GlobalVariable Property aaaGoldXPSkillXPConstant auto
GlobalVariable Property aaaGoldXPSkillXPGainCoefficient auto
GlobalVariable Property aaaGoldXPSkillXPGainConstant auto
GlobalVariable Property aaaGoldXPExponentialBase auto
GlobalVariable Property aaaGoldXPExponentialConstant auto
GlobalVariable Property aaaGoldXPExponentialCoefficient auto
GlobalVariable Property aaaGoldXPMaxSkillIncreasesPerLevel auto
GlobalVariable Property aaaGoldXPBuffered auto
GlobalVariable Property aaaGoldXPSkillXPBuffered auto
GlobalVariable Property aaaGoldXPExponentialEnable auto

;Text Properties
String Property SliderLabelBase auto
String Property SliderLabelCoefficient auto
String Property SliderLabelConstant auto
String Property SliderLabelSkillCostCoefficient auto
String Property SliderLabelSkillCostConstant auto
String Property SliderLabelSkillGainCoefficient auto
String Property SliderLabelSkillGainConstant auto
String Property SliderLabelSkillIncreasesPerLevel auto
String Property SliderLabelReductionConstant auto
String Property SliderLabelReductionCoefficient auto
String Property SliderLabelReductionLog auto
String Property SliderLabelDebugCurrentXP auto
String Property SliderLabelDebugSkillXP auto

String Property ToggleLabelExponential auto
String Property ToggleLabelReduction auto


String Property HighlightXPEquation auto
String Property HighlightSkillEquation auto
String Property HighlightSkillGain auto
String Property HighlightSkillMaxPerLevel auto
String Property HighlightReductionEquation auto
String Property HighlightGoldReductionPower auto
String Property HighlightExponentialEnable auto
String Property HighlightReductionEnable auto
String Property HighlightXPEquationAlt auto

String Property HeaderXPSettings auto
String Property HeaderSkillXPSettings auto
String Property HeaderGoldSettings auto
String Property IconLocation auto


int SliderBaseID
int SliderCoefficientID
int SliderConstantID
int SliderSkillCoefficientID
int SliderSkillConstantID
int SliderSkillGainConstantID
int SliderSkillGainCoefficientID
int SliderSkillMaxPerLevelID
int SliderReductionConstantID
int SliderReductionCoefficientID
int SliderGoldLogPowerID
int ToggleExponentialID
int ToggleReductionID

Event OnPageReset(string page)
	if(page == "")
		LoadCustomContent(IconLocation)
		return
	endif
	
	UnloadCustomContent()

	if(page == "Settings")
		
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		
		AddHeaderOption(HeaderXPSettings)
		ToggleExponentialID				= AddToggleOption(ToggleLabelExponential, aaaGoldXPExponentialEnable.getValue() != 0.0)
		SliderBaseID 					= AddSliderOption(SliderLabelBase, aaaGoldXPExponentialBase.getValue(), "{2}")
		SliderCoefficientID 			= AddSliderOption(SliderLabelCoefficient, aaaGoldXPExponentialCoefficient.getValue())
		SliderConstantID				= AddSliderOption(SliderLabelConstant, aaaGoldXPExponentialConstant.GetValue())
		
		AddHeaderOption(HeaderGoldSettings)
		ToggleReductionID				= AddToggleOption(ToggleLabelReduction, aaaGoldXPReductionLogPower.getValue() > 0.0)
		SliderReductionCoefficientID	= AddSliderOption(SliderLabelReductionCoefficient, aaaGoldXPReductionCoefficient.getValue())
		SliderReductionConstantID		= AddSliderOption(SliderLabelReductionConstant, aaaGoldXPReductionConstant.getValue())
		SliderGoldLogPowerID			= AddSliderOption(SliderLabelReductionLog, aaaGoldXPReductionLogPower.getValue(), "{2}")
		
		
		SetCursorPosition(1)
		AddHeaderOption(HeaderSkillXPSettings)
		SliderSkillCoefficientID 		= AddSliderOption(SliderLabelSkillCostCoefficient, aaaGoldXPSkillXPCoefficient.getValue(), "{2}")
		SliderSkillConstantID			= AddSliderOption(SliderLabelSkillCostConstant, aaaGoldXPSkillXPConstant.getValue(), "{2}")
		SliderSkillGainCoefficientID	= AddSliderOption(SliderLabelSkillGainCoefficient, aaaGoldXPSkillXPGainCoefficient.getValue(), "{2}")
		SliderSkillGainConstantID		= AddSliderOption(SliderLabelSkillGainConstant, aaaGoldXPSkillXPGainConstant.getValue(), "{2}")
		SliderSkillMaxPerLevelID		= AddSliderOption(SliderLabelSkillIncreasesPerLevel, aaaGoldXPMaxSkillIncreasesPerLevel.getValue(), "{2}")
		
		
	elseif( page == "Debug")
		SetCursorPosition(0)
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddTextOption(SliderLabelDebugCurrentXP, aaaGoldXPBuffered.getValue() as int, OPTION_FLAG_DISABLED)
		SetCursorPosition(1)
		AddTextOption(SliderLabelDebugSkillXP, aaaGoldXPSkillXPBuffered.getValue() as int, OPTION_FLAG_DISABLED)
	endif
	
EndEvent

Event OnOptionSelect(int option)
	if(option == ToggleExponentialID)
		
		aaaGoldXPExponentialEnable.setValue(AAAGoldXPExponentialEnable.getValue() * -1 + 1)
		bool bEnable = aaaGoldXPExponentialEnable.getValue() != 0.0
		
		SetToggleOptionValue(option, bEnable, true)
		
		if(bEnable)
			;Set slider defaults
			
			aaaGoldXPExponentialBase.setValue(1.1)
			aaaGoldXPExponentialCoefficient.setValue(250)
			aaaGoldXPExponentialConstant.setValue(1000)
		else
			;aaaGoldXPExponentialBase.setValue(1.0)
			aaaGoldXPExponentialCoefficient.setValue(250)
			aaaGoldXPExponentialConstant.setValue(750)
		endif
		
		SetSliderOptionValue(SliderBaseID, aaaGoldXPExponentialBase.getValue(), "{2}", true)
		SetSliderOptionValue(SliderCoefficientID, aaaGoldXPExponentialCoefficient.getValue(), "{0}", true)
		SetSliderOptionValue(SliderConstantID, aaaGoldXPExponentialConstant.getValue(), "{0}")
		
		
		
	elseif(option == ToggleReductionID)
		bool bEnable = aaaGoldXPReductionLogPower.getValue() == 0
		SetToggleOptionValue(option, bEnable, true)
		
		if(bEnable)
			aaaGoldXPReductionLogPower.setValue(2.4)
			aaaGoldXPReductionConstant.setValue(1000)
			aaaGoldXPReductionCoefficient.setValue(180)
		else
			aaaGoldXPReductionLogPower.setValue(0.0)
			aaaGoldXPReductionConstant.setValue(5000)
			aaaGoldXPReductionCoefficient.setValue(0)
		endif
		
		SetSliderOptionValue(SliderGoldLogPowerID, aaaGoldXPReductionLogPower.getValue(), "{2}", true)
		SetSliderOptionValue(SliderReductionConstantID, aaaGoldXPReductionConstant.getValue(), "{0}", true)
		SetSliderOptionValue(SliderReductionCoefficientID, aaaGoldXPReductionCoefficient.getValue(), "{0}", false)
		
	endif
EndEvent

Event OnOptionSliderOpen(int option)
	if(option == SliderBaseID)
		SetSliderDialogStartValue(aaaGoldXPExponentialBase.getValue())
		SetSliderDialogDefaultValue(1.1)
		SetSliderDialogRange(1.0, 1.25)
		SetSliderDialogInterval(0.01)
	elseif(option == SliderCoefficientID)
		SetSliderDialogStartValue(aaaGoldXPExponentialCoefficient.getValue())
		SetSliderDialogDefaultValue(250)
		SetSliderDialogRange(0, 2000)
		SetSliderDialogInterval(10)
	elseif(option == SliderConstantID)
		SetSliderDialogStartValue(aaaGoldXPExponentialConstant.getValue())
		SetSliderDialogDefaultValue(1000)
		SetSliderDialogRange(0, 2500)
		SetSliderDialogInterval(50)
	elseif(option == SliderSkillCoefficientID)
		SetSliderDialogStartValue(aaaGoldXPSkillXPCoefficient.getValue())
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.0, 5.0)
		SetSliderDialogInterval(0.1)
	elseif(option == SliderSkillConstantID)
		SetSliderDialogStartValue(aaaGoldXPSkillXPConstant.getValue())
		SetSliderDialogDefaultValue(0)
		SetSliderDialogRange(0, 20)
		SetSliderDialogInterval(0.1)
	elseif(option == SliderSkillGainCoefficientID)
		SetSliderDialogStartValue(aaaGoldXPSkillXPGainCoefficient.getValue())
		SetSliderDialogDefaultValue(6)
		SetSliderDialogRange(0, 20)
		SetSliderDialogInterval(0.1)
	elseif(option == SliderSkillGainConstantID)
		SetSliderDialogStartValue(aaaGoldXPSkillXPGainConstant.getValue())
		SetSliderDialogDefaultValue(153)
		SetSliderDialogRange(50, 200)
		SetSliderDialogInterval(1)
	elseif(option == SliderSkillMaxPerLevelID)
		SetSliderDialogStartValue(aaaGoldXPMaxSkillIncreasesPerLevel.getValue())
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(2, 10)
		SetSliderDialogInterval(0.1)
	elseif(option == SliderReductionConstantID)
		SetSliderDialogStartValue(aaaGoldXPReductionConstant.getValue())
		SetSliderDialogDefaultValue(1000)
		SetSliderDialogRange(500, 5000)
		SetSliderDialogInterval(100)
	elseif(option == SliderReductionCoefficientID)
		SetSliderDialogStartValue(aaaGoldXPReductionCoefficient.getValue())
		SetSliderDialogDefaultValue(180)
		SetSliderDialogRange(0,500)
		SetSliderDialogInterval(10)
	elseif(option == SliderGoldLogPowerID)
		SetSliderDialogStartValue(aaaGoldXPReductionLogPower.getValue())
		SetSliderDialogDefaultValue(2.4)
		SetSliderDialogRange(0.0, 5.0)
		SetSliderDialogInterval(0.1)	
	endif
EndEvent

Event OnOptionSliderAccept(int option, float value)
	if(option == SliderBaseID)
		aaaGoldXPExponentialBase.setValue(value)
		bool bEnable = value > 1.0
		setToggleOptionValue(ToggleExponentialID, bEnable)
		SetSliderOptionValue(option, value, "{2}")
	elseif(option == SliderCoefficientID)
		aaaGoldXPExponentialCoefficient.setValue(value)
		SetSliderOptionValue(option, value, "{0}")
	elseif(option == SliderConstantID)
		aaaGoldXPExponentialConstant.setValue(value)
		SetSliderOptionValue(option, value, "{0}")
	elseif(option == SliderSkillCoefficientID)
		aaaGoldXPSkillXPCoefficient.setValue(value)
		SetSliderOptionValue(option, value, "{2}")
	elseif(option == SliderSkillConstantID)
		aaaGoldXPSkillXPConstant.setValue(value)
		SetSliderOptionValue(option, value, "{2}")
	elseif(option == SliderSkillGainCoefficientID)
		aaaGoldXPSkillXPGainCoefficient.setValue(value)
		SetSliderOptionValue(option, value, "{2}")
	elseif(option == SliderSkillGainConstantID)
		aaaGoldXPSkillXPGainConstant.setValue(value)
		SetSliderOptionValue(option, value, "{0}")
	elseif(option == SliderSkillMaxPerLevelID)
		aaaGoldXPMaxSkillIncreasesPerLevel.setValue(value)
		SetSliderOptionValue(option, value, "{2}")
	elseif(option == SliderReductionConstantID)
		aaaGoldXPReductionConstant.setValue(value)
		SetSliderOptionValue(option, value, "{0}")
	elseif(option == SliderReductionCoefficientID)
		aaaGoldXPReductionCoefficient.setValue(value)
		SetSliderOptionValue(option, value, "{0}")
	elseif(option == SliderGoldLogPowerID)
		aaaGoldXPReductionLogPower.setValue(value)
		bool bEnable = value > 0.0
		setToggleOptionValue(ToggleReductionID, bEnable)
		SetSliderOptionValue(option, value, "{2}")
		
	endif
	
EndEvent

Event OnOptionHighlight(int option)
	if(option == SliderBaseID || option == SliderCoefficientID || option == SliderConstantID)
		if(aaaGoldXPExponentialBase.getValue() > 1.0)
			SetInfoText(HighlightXPEquation)
		else	
			SetInfoText(HighlightXPEquationAlt)
		endif
	elseif(option == SliderSkillCoefficientID || option == SliderSkillConstantID)
		SetInfoText(HighlightSkillEquation)
	elseif(option == SliderSkillGainCoefficientID || option == SliderSkillGainConstantID)
		SetInfoText(HighlightSkillGain)
	elseif(option == SliderSkillMaxPerLevelID)
		SetInfoText(HighlightSkillMaxPerLevel)
	elseif(option == SliderReductionConstantID || option == SliderReductionCoefficientID)
		SetInfoText(HighlightReductionEquation)
	elseif(option == SliderGoldLogPowerID)
		SetInfoText(HighlightGoldReductionPower)
	elseif(option == ToggleExponentialID)
		SetInfoText(HighlightExponentialEnable)
	elseif(option == ToggleReductionID)
		SetInfoText(HighlightReductionEnable)
	endif
EndEvent
